<?php

/**
 * co_campo_ep_prueba actions.
 *
 * @package    contratacion
 * @subpackage co_campo_ep_prueba
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class co_campo_epActions extends sfActions {

    /**
     * Executes index action
     *
     * @param sfRequest $request A request object
     */
    public function executeList(sfWebRequest $request) {
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            /*
             * Paginacion
             */
            if (isset($request['_startRow'])) {
                $rowStart = $request['_startRow'];
            } else {
                $rowStart = 0;
            }

            if (isset($request['_endRow'])) {
                $rowEnd = $request['_endRow'];
            } else {
                $rowEnd = 75;
            }
            //Filtros
            $filtro_descripcion = '';
            if (isset($request['descripcion'])) {
                $filtro = strtoupper($request['descripcion']);
                $filtro_descripcion = "and upper(tab0.descripcion) like '%$filtro%'";
            }
            //fin filtros
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * sql que trae los resultados
             * por los filtros, para totalizar las filas
             */
            $sql = <<<EOD
select count(*) as count from CO_CAMPO_EP
EOD;
            $total_record_count = CN_TABLE::executeSQL($sql);
            $total_record_count = $total_record_count[0]["count"];
            
            //validar si hay registros
            if ($total_record_count > 0) {
                
                $sql = <<<EOD
SELECT * FROM ( SELECT row_.*, ROWNUM rownum_ FROM (
SELECT 
tab0.id_campo_ep,
tab0.codigo,
tab0.descripcion,
tab0.estado,
tab0.fase_ep.id_fase_ep as id_fase_ep,
tab0.tipo_campo,
tab0.tamano_campo,
tab0.aplica_relacion,
tab0.tabla_cc.id_tabla_cc as id_tabla_cc,
tab0.tipo_captura.id_tipo_captura as id_tipo_captura,
tab0.obligatorio,
tab0.campo_fijo,
tab0.fase_ep.descripcion as descripcion_fases,
tab0.tipo_captura.descripcion as descripcion_tipocaptura,
tab0.tabla_cc.tabla as tabla,
tab0.tabla_cc.cc as nombre_cc
FROM CO_CAMPO_EP tab0
WHERE 1=1
$filtro_descripcion
) row_ WHERE ROWNUM <=  $rowEnd   ) where rownum_ >  $rowStart
EOD;
                //ejecuta y obtiene el resultado del sql
                $records = CN_TABLE::executeSQL($sql);
                // Solo registra log la primera vez de consulta
                if ($rowStart == 0) {
                    //Operaciones: 1-CONSULTAR, 2-ACTUALIZAR, 3-ADICIONAR, 4-ELIMINAR, 5-ANULAR
                    $id_ope_bd = 1;
                    //obtener id maestro tabla
                    $id_mae_bd = CN_TABLE::consultarIdTablaBD('CO_CAMPO_EP');
                    //registro de consulta en tabla de log- la observacion puede o no enviarse ($request, $id_ope_bd, $id_mae_bd, $observacion)
                    //  $sql = CN_TABLE::registrarLog($request, $id_ope_bd, $id_mae_bd);
                }
                $this->totalRows = $total_record_count;
                $this->startRow = $rowStart;
                $this->endRow = $rowStart + count($records);
                $this->status = 0;
                $this->list_data = $records;
                $this->logMessage("[INF_CO_CAMPO_EP] Consulta exitosa.");
            } else {

                $mensaje = "[INF_CO_CAMPO_EP] No hay registros de consulta.";
                $this->status = 0;
                $this->list_data = array();
                $this->logMessage($mensaje);
            }
        } catch (Exception $e) {
            $error = "[INF_CO_CAMPO_EP] ERROR: " . $e->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    public function executeAdd(sfWebRequest $request) {
        $this->logMessage("[INF_CO_CAMPO_EP] Entra por agregar objeto.");
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $codigo = $request['codigo'];
            $descripcion = $request['descripcion'];
            $estado = $request['estado'];
            if ($estado == "true") {
                $estado = 1;
            } else {
                $estado = 0;
            }
            $id_fase_ep = $request['id_fase_ep'];
            $tipo_campo = $request['tipo_campo'];
            $tamano_campo = $request['tamano_campo'];
            $aplica_relacion = $request['aplica_relacion'];
            if ($aplica_relacion == "true") {
                $aplica_relacion = 1;
            } else {
                $aplica_relacion = 0;
            }
            $tabla_relacion = $request['tabla_relacion'];
            $campo_relacion = $request['campo_relacion'];
            $id_tipo_captura = $request['id_tipo_captura'];
            $obligatorio = $request['obligatorio'];
            if ($obligatorio == "true") {
                $obligatorio = 1;
            } else {
                $obligatorio = 0;
            }
            $id_tabla_cc = $request['id_tabla_cc'];
            $campo_fijo = $request['campo_fijo'];
            if ($campo_fijo == "true") {
                $campo_fijo = 1;
            } else {
                $campo_fijo = 0;
            }
            if (isset($request['id_tabla_cc'])) {
                $sql = <<<EOD
INSERT INTO CO_CAMPO_EP (ID_CAMPO_EP,CODIGO,DESCRIPCION,ESTADO,FASE_EP,TIPO_CAMPO,TAMANO_CAMPO,APLICA_RELACION,TIPO_CAPTURA,OBLIGATORIO,TABLA_CC,CAMPO_FIJO) VALUES ('','$codigo','$descripcion','$estado',(SELECT REF(e) FROM CO_FASE_EP e WHERE e.ID_FASE_EP=$id_fase_ep),'$tipo_campo',$tamano_campo,$aplica_relacion,(SELECT REF(t) FROM CO_TIPO_CAPTURA t WHERE t.ID_TIPO_CAPTURA=$id_tipo_captura),$obligatorio,(SELECT REF(t) FROM CO_TABLA_CC t WHERE t.ID_TABLA_CC=$id_tabla_cc),$campo_fijo)
EOD;
            } else {
                $sql = <<<EOD
INSERT INTO CO_CAMPO_EP (ID_CAMPO_EP,CODIGO,DESCRIPCION,ESTADO,FASE_EP,TIPO_CAMPO,TAMANO_CAMPO,APLICA_RELACION,TIPO_CAPTURA,OBLIGATORIO,TABLA_CC,CAMPO_FIJO) VALUES ('','$codigo','$descripcion','$estado',(SELECT REF(e) FROM CO_FASE_EP e WHERE e.ID_FASE_EP=$id_fase_ep),'$tipo_campo',$tamano_campo,$aplica_relacion,(SELECT REF(t) FROM CO_TIPO_CAPTURA t WHERE t.ID_TIPO_CAPTURA=$id_tipo_captura),$obligatorio,null,$campo_fijo)
EOD;
            }
            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql);
            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[INF_CO_CAMPO_EP] Consulta exitosa");
        } catch (Exception $ex) {
            $error = "[INF_CO_CAMPO_EP] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    public function executeUpdate(sfWebRequest $request) {
        $this->logMessage("[INF_CO_CAMPO_EP] Entra por editar objeto.");
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id = $request['id_campo_ep'];
            $codigo = $request['codigo'];
            $descripcion = $request['descripcion'];
            $estado = $request['estado'];
            if ($estado == "true") {
                $estado = 1;
            } else {
                $estado = 0;
            }
            $id_fase_ep = $request['id_fase_ep'];
            $tipo_campo = $request['tipo_campo'];
            $tamano_campo = $request['tamano_campo'];
            $aplica_relacion = $request['aplica_relacion'];
            if ($aplica_relacion == "true") {
                $aplica_relacion = 1;
            } else {
                $aplica_relacion = 0;
            }
            $tabla_relacion = $request['tabla_relacion'];
            $campo_relacion = $request['campo_relacion'];
            $id_tipo_captura = $request['id_tipo_captura'];
            $obligatorio = $request['obligatorio'];
            if ($obligatorio == "true") {
                $obligatorio = 1;
            } else {
                $obligatorio = 0;
            }
            $campo_fijo = $request['campo_fijo'];
            if ($campo_fijo == "true") {
                $campo_fijo = 1;
            } else {
                $campo_fijo = 0;
            }
            $id_tabla_cc = $request['id_tabla_cc'];
            if (isset($request['id_tabla_cc'])) {
                $sql = <<<EOD
UPDATE CO_CAMPO_EP SET CODIGO='$codigo',DESCRIPCION='$descripcion',ESTADO=$estado,FASE_EP=(SELECT REF(e) FROM CO_FASE_EP e WHERE e.ID_FASE_EP=$id_fase_ep),TIPO_CAMPO='$tipo_campo',TAMANO_CAMPO=$tamano_campo,APLICA_RELACION=$aplica_relacion,TIPO_CAPTURA=(SELECT REF(t) FROM CO_TIPO_CAPTURA t WHERE t.ID_TIPO_CAPTURA=$id_tipo_captura),OBLIGATORIO=$obligatorio,TABLA_CC=(SELECT REF(t) FROM CO_TABLA_CC t WHERE t.ID_TABLA_CC=$id_tabla_cc),CAMPO_FIJO=$campo_fijo WHERE ID_CAMPO_EP=$id
EOD;
                $consulta = "(SELECT REF(t) FROM CO_TABLA_CC t WHERE t.ID_TABLA_CC=$id_tabla_cc)";
            } else {
                $sql = <<<EOD
UPDATE CO_CAMPO_EP SET CODIGO='$codigo',DESCRIPCION='$descripcion',ESTADO=$estado,FASE_EP=(SELECT REF(e) FROM CO_FASE_EP e WHERE e.ID_FASE_EP=$id_fase_ep),TIPO_CAMPO='$tipo_campo',TAMANO_CAMPO=$tamano_campo,APLICA_RELACION=$aplica_relacion,TIPO_CAPTURA=(SELECT REF(t) FROM CO_TIPO_CAPTURA t WHERE t.ID_TIPO_CAPTURA=$id_tipo_captura),OBLIGATORIO=$obligatorio,CAMPO_FIJO=$campo_fijo WHERE ID_CAMPO_EP=$id
EOD;
            }
            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql);
            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[INF_CO_CAMPO_EP] Consulta exitosa");
        } catch (Exception $ex) {
            $error = "[INF_CO_CAMPO_EP] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

    public function executeRemove(sfWebRequest $request) {
        $this->logMessage("[INF_CO_CAMPO_EP] Entra por eliminar objeto.");
        //Revisar que sea post
        //$this->forward404Unless($request->isMethod('post'));
        //Guardar los parametros del request en el log
        $this->logMessage("---BEGIN Logging request");
        foreach ($request->getPostParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("--------------------------------------------------*  Ip: " . $_SERVER['REMOTE_ADDR']);
        foreach ($request->getGetParameters() as $key => $value) {
            $this->logMessage("request[$key] = $value");
        }
        $this->logMessage("---END Logging request");

        /*
         * Manejo de errores
         */
        try {
            $sql = <<<EOD
 ALTER SESSION SET NLS_DATE_FORMAT = "YYYY-MM-DD"
EOD;
            CN_TABLE::executeSQL($sql);
            /*
             * SQL QUE INSERTA EN LA TABLA DE OBJETO RELACION LOS DATOS 
             */
            $id = $request['id_campo_ep'];
            $sql = <<<EOD
DELETE FROM CO_CAMPO_EP WHERE ID_CAMPO_EP=$id
EOD;
            //ejecuta y obtiene el resultado del sql
            $records = CN_TABLE::executeSQL($sql);
            $this->status = 0;
            $this->list_data = $records;
            $this->logMessage("[INF_CO_FASE_EP] Consulta exitosa, DATO ELIMINADO:$id");
        } catch (Exception $ex) {
            $error = "[INF_CO_FASE_EP] ERROR: " . $ex->getMessage();
            $this->status = 1;
            $this->list_data = array();
            $this->mensajeError = $error;
            $this->logMessage($error);
        }
    }

}
